Package org.eclipse.cdt.core.dom.ast

# Interface IASTAttributeSpecifier

All Superinterfaces:
  `IASTNode`

All Known Subinterfaces:
  `IASTAttributeList`, `ICPPASTAlignmentSpecifier`, `ICPPASTAttributeList`, `ICPPASTAttributeSpecifier`, `IGCCASTAttributeList`, `IGCCASTAttributeSpecifier`, `IMSASTDeclspecList`

public interface IASTAttributeSpecifier extends IASTNode
Represents a C++11 (ISO/IEC 14882:2011 7.6.1) or a GCC attribute specifier (http://gcc.gnu.org/onlinedocs/gcc/Attribute-Syntax.html).

Since:
  5.7
Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`IASTNode.CopyStyle`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final ASTNodeProperty`
`ATTRIBUTE`
`static final IASTAttributeSpecifier[]`
`EMPTY_ATTRIBUTE_SPECIFIER_ARRAY`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`EMPTY_NODE_ARRAY`

## Method Summary

Modifier and Type
Method
Description
`void`
`addAttribute(IASTAttribute attribute)`
Deprecated.
Use IASTAttributeList.addAttribute() instead.
`IASTAttributeSpecifier`
`copy()`
Returns a mutable copy of the tree rooted at this node.
`IASTAttributeSpecifier`
`copy(IASTNode.CopyStyle style)`
Returns a mutable copy of the tree rooted at this node.
`IASTAttribute[]`
`getAttributes()`
Deprecated.
Use IASTAttributeList.getAttributes() instead.

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`accept, contains, getChildren, getContainingFilename, getFileLocation, getLeadingSyntax, getNodeLocations, getOriginalNode, getParent, getPropertyInParent, getRawSignature, getSyntax, getTrailingSyntax, getTranslationUnit, isActive, isFrozen, isPartOfTranslationUnitFile, setParent, setPropertyInParent`

## Field Details

### EMPTY_ATTRIBUTE_SPECIFIER_ARRAY

static final IASTAttributeSpecifier[] EMPTY_ATTRIBUTE_SPECIFIER_ARRAY

### ATTRIBUTE

static final ASTNodeProperty ATTRIBUTE

## Method Details

### getAttributes

@Deprecated IASTAttribute[] getAttributes()
Deprecated.
Use IASTAttributeList.getAttributes() instead.

Restriction:
  This method is not intended to be referenced by clients.

### addAttribute

@Deprecated void addAttribute(IASTAttribute attribute)
Deprecated.
Use IASTAttributeList.addAttribute() instead.

Restriction:
  This method is not intended to be referenced by clients.

### copy

IASTAttributeSpecifier copy()
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Calling this method is equivalent to `copy(CopyStyle.withoutLocations)`.

Specified by:
  `copy` in interface `IASTNode`

### copy

IASTAttributeSpecifier copy(IASTNode.CopyStyle style)
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Specified by:
  `copy` in interface `IASTNode`
Parameters:
  `style` - `IASTNode.CopyStyle` create a copy with or without locations. Please see `IASTNode.CopyStyle` for restrictions on copies with Locations.